import java.io.*;

public class ICFP2001 {
	public static void main( String[] args ) {
//		test1();
		run();
	}
	
	private static void run() {
		SMLParser parser = new SMLParser();
		Statement doc = parser.parseGrammar(System.in);
		if( doc != null ) {
			System.out.print(doc);
		}
	}
	
	private static void test1() {
		String[] strs = {
			"<r>  xxx </r><b> yyy  </b>",
			"<r> xxx  <b>  yyy </b></r>",
			"<EM> xxx <EM> yyy </EM> zzz </EM>",
			"<EM> xxx</EM> yyy <EM>  zzz </EM>",
			"<B> xxx <B> yyy </B></B>",
			"<B> xxx  yyy </B>",
			"<r> xxx </r><b> </b><r> yyy </r>",
			"<r> xxx yyy </r>",
			"<EM> xxx <S> yyy </S></EM>",
			"<EM> xxx </EM><S> yyy </S>",
			"<I> xxx </I> yyy <I> zzz </I>",
			"<I> xxx <PL> yyy </PL> zzz </I>",
			"<TT><r>  xxx </r><b> yyy  </b></TT>",
			"<TT><r> xxx  <b>  yyy </b></r></TT>",
			"<B> xxx <I> yyy </I> zzz </B>",
			"<B> xxx </B><I> yyy </I><B> zzz </B>",
			"<U> xxx <U> yyy </U></U>",
			"<U> xxx  yyy </U>",
			"<U><r> xxx </r><b> </b><r> yyy </r></U>",
			"<U><r> xxx   yyy </r></U>",
			""
		};
  								
		for( int i=0; i<strs.length; i++ ) {
			ByteArrayInputStream in = new ByteArrayInputStream(strs[i].getBytes());
			
			SMLParser parser = new SMLParser();
			Statement doc = parser.parseGrammar(in);
			if( doc != null ) {
				System.out.println(""+i+":");
				System.out.println(strs[i]);
				System.out.println(doc);
			}
			System.out.println();
		}
	}
}
